Graphics3D 640, 480, 0, 2
SetBuffer BackBuffer()

Global Texture%
Global Displacemap%
Global Sphere%
Global Camera%
Global Light%

Texture%     = LoadTexture("texture.png")
Displacemap% = LoadImage("displacemap.png")
Sphere%      = CreateSphere(60)
EntityTexture Sphere%, Texture%
DisplaceMesh Sphere%, Displacemap%, 0.3

Camera% = CreateCamera()
PositionEntity Camera%, 0.0, 0.0, -3.0

Light% = CreateLight(1, Camera%)

While Not KeyDown(1)
	TurnEntity Sphere%, 0.0, 1.0, 1.0

	UpdateWorld()
	RenderWorld()
	Flip()
Wend

EndGraphics()
End

Function DisplaceMesh(Mesh%, Map%, Strength#=1.0)
	Local Width#, Height#, OldBuffer%, Index%, Surface%, Vertex%
	Local X#, Y#, Z#, NX#, NY#, NZ#, U#, V#
	Local PixelX%, PixelY%, R%, G%, B%
	Local Displacement#
	
	Width#  = Float#(ImageWidth(Map%))
	Height# = Float#(ImageHeight(Map%))

	OldBuffer% = GraphicsBuffer()
	SetBuffer ImageBuffer(Map%)
	LockBuffer()
	
	For Index% = 1 To CountSurfaces(Mesh%)
		Surface% = GetSurface(Mesh%, Index%)
		For Vertex% = 0 To CountVertices(Surface%)-1
			X# = VertexX#(Surface%, Vertex%)
			Y# = VertexY#(Surface%, Vertex%)
			Z# = VertexZ#(Surface%, Vertex%)
			
			NX# = VertexNX#(Surface%, Vertex%)
			NY# = VertexNY#(Surface%, Vertex%)
			NZ# = VertexNZ#(Surface%, Vertex%)
			
			U# = VertexU#(Surface%, Vertex%)
			V# = VertexV#(Surface%, Vertex%)
			
			PixelX% = Int(U#*Width#) Mod Int(Width#)
			PixelY% = Int(V#*Height#) Mod Int(Height#)
			DebugLog PixelX+" "+PixelY
			
			Colour% = ReadPixelFast(PixelX, PixelY)
			R% = (Colour% Shr 16) And $FF
			G% = (Colour% Shr 8) And $FF
			B% = Colour% And $FF
			Displacement# = (Float(R% + G% + B%)/(255.0*3.0))*Strength#
			
			X# = X# + NX#*Displacement#
			Y# = Y# + NY#*Displacement#
			Z# = Z# + NZ#*Displacement#
			VertexCoords Surface%, Vertex%, X#, Y#, Z#
		Next
	Next
	
	UnlockBuffer()
	SetBuffer OldBuffer%
End Function